import java.awt.Dimension;
import java.awt.Rectangle;
import java.awt.peer.CheckboxPeer;

import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;


public class GUI extends JFrame{
	
	private JPanel jContentPane;
	
	private JTabbedPane jTabbedPane;
	
	private JPanel jPanelMapa1,jPanelMapa2,jPanelMapa3;
	
	private PainelPontos mapPanel1,mapPanel2,mapPanel3;
	
	private JCheckBox checkPontosDaCurva,checkPoligonal,checkBezier;
	private JLabel lblPontosDaCurva,lblPoligonal,lblBezier;
	
	public GUI(){
		super("Projeto PG");
		setDefaultCloseOperation( JFrame.DISPOSE_ON_CLOSE );   
		getJFrame();
	}

	/**
	 * This method initializes jFrame	
	 * 	
	 * @return javax.swing.JFrame	
	 */
	private JFrame getJFrame() {
		this.setSize(new Dimension(734, 800));
		this.setContentPane(getJContentPane());
		this.setVisible(true);
		this.setExtendedState(JFrame.MAXIMIZED_BOTH);   
		return this;
	}

	/**
	 * This method initializes jContentPane	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(getJTabbedPane(),null);
		}
		return jContentPane;
	}
	
	private JCheckBox getCheckBoxPontosDaCurva() {
		if(checkPontosDaCurva == null){
			checkPontosDaCurva = new JCheckBox();
			checkPontosDaCurva.setBounds(10, 50, 20, 20);
			checkPontosDaCurva.setVisible(true);
		}
		
		checkPontosDaCurva.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				
				if(checkPontosDaCurva.isSelected()){
					for(Ponto p: mapPanel1.pontosDaCurva){
						p.setVisible(false);
					}
				}
				else{
					for(Ponto p: mapPanel1.pontosDaCurva){
						p.setVisible(true);
					}
				}
				
				jContentPane.repaint();
			}
		});
		return checkPontosDaCurva;
	}
	
	private JCheckBox getCheckBoxPoligonal() {
		if(checkPoligonal == null){
			checkPoligonal = new JCheckBox();
			checkPoligonal.setBounds(10, 70, 20, 20);
			checkPoligonal.setVisible(true);
		}
		
		checkPoligonal.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				
				if(checkPoligonal.isSelected()){
					mapPanel1.desenharLinhas = false;
				}
				else{
					mapPanel1.desenharLinhas = true;
				}
				
				jContentPane.repaint();
			}
		});
		
		return checkPoligonal;
	}
	
	private JCheckBox getCheckBoxBezier() {
		if(checkBezier == null){
			checkBezier = new JCheckBox();
			checkBezier.setBounds(10, 90, 20, 20);
			checkBezier.setVisible(true);			
		}
		
		checkBezier.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				
				if(checkBezier.isSelected()){
					for(Ponto p: mapPanel1.pontosDeBezierC1){
						p.setVisible(false);
					}
				}
				else{
					for(Ponto p: mapPanel1.pontosDeBezierC1){
						p.setVisible(true);
					}
				}
				
				jContentPane.repaint();
			}
		});
		
		return checkBezier;
	}

	private JLabel getLabelPontosDaCurva() {
		if(lblPontosDaCurva == null){
			lblPontosDaCurva = new JLabel("Suprimir pontos de curva");
			lblPontosDaCurva.setBounds(40, 45, 150, 30);
			lblPontosDaCurva.setVisible(true);
		}
		return lblPontosDaCurva;
	}
	
	private JLabel getLabelPoligonal() {
		if(lblPoligonal == null){
			lblPoligonal = new JLabel("Suprimir poligonal");
			lblPoligonal.setBounds(40, 65, 150, 30);
			lblPoligonal.setVisible(true);
		}
		return lblPoligonal;
	}
	
	private JLabel getLabelBezier() {
		if(lblBezier == null){
			lblBezier = new JLabel("Suprimir pontos de Bezier");
			lblBezier.setBounds(40, 85, 150, 30);
			lblBezier.setVisible(true);
		}
		return lblBezier;
	}
	
	/**
	 * This method initializes jTabbedPane	
	 * 	
	 * @return javax.swing.JTabbedPane	
	 */
	private JTabbedPane getJTabbedPane() {
		if (jTabbedPane == null) {
			jTabbedPane = new JTabbedPane();
			jTabbedPane.setBounds(new Rectangle(20, 19, 980, 680));
			jTabbedPane.addTab("Aba 1", null, getJPanelMapa1(), null);
		}
		return jTabbedPane;
	}
	
	private JPanel getJPanelMapa1() {
		if (jPanelMapa1 == null) {
			jPanelMapa1 = new JPanel();
			jPanelMapa1.setLayout(null);
			jPanelMapa1.add(getCheckBoxPontosDaCurva(),null);
			jPanelMapa1.add(getCheckBoxPoligonal(),null);
			jPanelMapa1.add(getCheckBoxBezier(),null);
			
			jPanelMapa1.add(getLabelPontosDaCurva(),null);
			jPanelMapa1.add(getLabelPoligonal(),null);
			jPanelMapa1.add(getLabelBezier(),null);
			
			jPanelMapa1.add(getPainelPontos1(),null);	
		}
		return jPanelMapa1;
	}
			
	private PainelPontos getPainelPontos1() {
		
		mapPanel1 = new PainelPontos(true);
		
		mapPanel1.setBounds(new Rectangle(206, 13, 600, 600));
		mapPanel1.setLayout(null);
		mapPanel1.setVisible(true);
		
		return mapPanel1;
	}
	
	public static void main(String[] args) {
		new GUI();
	}
}
