import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.Shape;
import java.awt.geom.Ellipse2D;
import java.awt.geom.Rectangle2D;

import javax.swing.JComponent;


public class Ponto extends JComponent{
	
	public double x,y;
	public String tipo;
	
	public Ponto(double d,double e, String tipo){
		this.x = d;
		this.y = e;
		this.tipo = tipo;
		this.setBounds(new Rectangle((int)d, (int)e, 10, 10));
		this.setVisible(true);
	}
	
	public void paintComponent(Graphics g) {
		Graphics2D ga = (Graphics2D)g;
		
		if(tipo.equals("Entrada")){
			Shape circle = new Ellipse2D.Float(0, 0, 7.0f, 7.0f);
			ga.setPaint(Color.black);

			ga.draw(circle);
			ga.fill(circle);
		}
		else if(tipo.equals("C1")){
			Shape rectangle = new Rectangle2D.Double(0, 0, 7, 7);
			ga.setPaint(Color.green);

			ga.draw(rectangle);
			ga.fill(rectangle);
		}
		else if(tipo.equals("C2")){
			Shape rectangle = new Rectangle2D.Double(0, 0, 7, 7);
			ga.setPaint(Color.gray);

			ga.draw(rectangle);
			ga.fill(rectangle);
		}
		else{
			Shape rectangle = new Rectangle2D.Double(0, 0, 10, 10);
			ga.setPaint(Color.red);

			ga.draw(rectangle);
			ga.fill(rectangle);
		}

	}
	
	/*
	 * Mtodo utilizado para calcular o ponto de controle 
	 * para segmentos com apenas um ponto de controle		
	 */
	
	public Ponto interpolacaoLinear(Ponto next){
		// Implementar
		return new Ponto((x+next.x)/2,(y+next.y)/2,"Bezier"); 
	}
	
	/*
	 * Mtodo utilizado para calcular o ponto de controle 
	 * para segmentos com dois pontos de controle		
	 */	
	public Ponto getPrimeiroPontoInterpolacao(Ponto next){
		// Implementar
		return new Ponto((2*x+next.x)/3,(2*y+next.y)/3,"Bezier");
	}
	
	/*
	 * Mtodo utilizado para calcular o ponto de controle 
	 * para segmentos com dois pontos de controle		
	 */	
	public Ponto getSegundoPontoInterpolacao(Ponto next){
		// Implementar
		return new Ponto((x+2*next.x)/3,(y+2*next.y)/3,"Bezier");
	}
	
	public Ponto bezierC1 (Ponto a, Ponto b, double t) {
		double x = (1-t)*(1-t)*(a.x) + 2*t*(1-t)*(b.x) + t*t*(this.x);
		double y = (1-t)*(1-t)*(a.y) + 2*t*(1-t)*(b.y) + t*t*(this.y);
		
		Ponto retorno = new Ponto (x,y,"C1");
		return retorno;
	}
	
	public Ponto bezierC2 (Ponto a, Ponto b, Ponto c, double t) {
		double x = (1-t)*(1-t)*(1-t)*(a.x) + 3*t*(1-t)*(1-t)*(b.x) + 3*t*t*(1-t)*(c.x) + t*t*t*(this.x);
		double y = (1-t)*(1-t)*(1-t)*(a.y) + 3*t*(1-t)*(1-t)*(b.y) + 3*t*t*(1-t)*(c.y) + t*t*t*(this.y);
		
		Ponto retorno = new Ponto (x,y,"C2");
		return retorno;
	}
}
